// 002 u_business_objects_generator
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_business_objects_generator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, DB, IBDatabase, IBExtract, IBCustomDataSet,
  IBQuery, Grids, DBGrids, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBExtract1: TIBExtract;
    IBQuery1: TIBQuery;
    DataSource1: TDataSource;
    PageControl1: TPageControl;
    db_: TTabSheet;
    generate__: TTabSheet;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    ListBox1: TListBox;
    display_table_: TTabSheet;
    DBGrid1: TDBGrid;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    before_edit_: TCheckBox;
    after_edit_: TCheckBox;
    before_post_: TCheckBox;
    after_post_: TCheckBox;
    before_close_: TCheckBox;
    after_close_: TCheckBox;
    generate_: TButton;
    field_listbox_: TListBox;
    generate_project_: TButton;
    PageControl2: TPageControl;
    display_: TTabSheet;
    Memo1: TMemo;
    dataset_: TTabSheet;
    dataset_memo_: TMemo;
    module__: TTabSheet;
    module_memo_: TMemo;
    edit_form_pas_: TTabSheet;
    edit_form_pas_memo_: TMemo;
    Panel6: TPanel;
    table_: TCheckBox;
    module_: TCheckBox;
    form_: TCheckBox;
    Panel7: TPanel;
    tables_: TButton;
    two_steps_: TCheckBox;
    Panel8: TPanel;
    first_field_gen_: TCheckBox;
    first_field_validate_: TCheckBox;
    read_only_: TCheckBox;
    field_underscore_: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tables_Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure generate_Click(Sender: TObject);
    procedure generate_project_Click(Sender: TObject);
  private
    procedure generate_minimal_table_unit(p_table_name: String);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display
        , u_file, u_dir, u_exe
        , u_c_ini_file
        , u_strings
        , u_c_generator_2

        , u_c_generate_dataset
        // , u_c_generate_sql_queries
        , u_c_generate_module

        , u_c_generate_form, u_c_generate_dpr
        ;

    {$R *.DFM}

    const k_initial_path= 'c:\prog\uti_del\shell\';
            k_file_name= 'e.ed';
            k_extension= '.*';

          k_raw_component_segment= '_raw_components\';
          k_raw_form_segment= '_raw_forms\';
          k_result_segment= '_result_dpr\';

          // -- ini keys
          k_save_path= k_initial_path;
          k_save_name= k_file_name;

          k_load_path_ini_key=      'load_fig_path';
          k_load_file_name_ini_key= 'load_fig_file_name';

    var g_path: String= k_initial_path;
        g_file_name: String= k_file_name;
        g_c_ini_file: c_ini_file= Nil;
        g_c_edit_form_list: tStringList= Nil;

    procedure handle_file(p_path, p_file_name: String);
      begin
        display(p_file_name);
      end; // handle_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_load_path_ini_key, k_save_path);
          g_file_name:= f_initialize_parameter(k_load_file_name_ini_key, k_save_name);
        end;

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        FileListBox1.Mask:= '*'+ k_extension;

        g_c_edit_form_list:= tStringList.Create;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_path_ini_key, g_path);
      end; // DirectoryListBox1Change

    // -- file handling

    procedure TForm1.FileListBox1Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        display(g_path+ ' '+ g_file_name);
        g_c_ini_file.set_parameter(k_load_file_name_ini_key, g_file_name);

        handle_file(g_path, g_file_name);

        display_line;
        display('finished');

        with IbDatabase1 do
        begin
          DatabaseName:= g_path+ g_file_name;
        end;
      end; // FileListBox1Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        g_c_edit_form_list.Free;
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    procedure TForm1.tables_Click(Sender: TObject);
        // -- fill a ListBox with all table name
      var l_item: Integer;
          l_index: Integer;
          l_the_line, l_table_name: String;
      begin
        IbDatabase1.Open;

        with IBExtract1 do
        begin
          ExtractObject(eoTable, '');
          // Listbox1.Items.Assign(Items);

          with Items do
            for l_item:= 0 to Count- 1 do
            begin
              display(Strings[l_item]);
              l_the_line:= Strings[l_item];

              if Pos('CREATE TABLE', l_the_line)> 0
                then begin
                    l_index:= 1;
                    f_string_extract_non_blank(l_the_line, l_index);
                    f_string_extract_non_blank(l_the_line, l_index);
                    l_table_name:= f_string_extract_non_blank(l_the_line, l_index);
                    Listbox1.Items.Add(l_table_name);
                  end
                else
                  if POS('PRIMARY KEY', l_the_line)> 0
                    then begin
                        // display('*** PRIM');
                      end;
            end; // with Items
        end; // with IBExtract1
      end; // tables_Click

    procedure tForm1.generate_minimal_table_unit(p_table_name: String);
        // -- no separate creation. Always create the classes, only
        // --   separate the open()
      var l_class_name: String;
          l_constructor_name: String;
          l_first_field_name: String;
          l_field_underscore: String;

      procedure open_the_table_query;
        begin
          with ibQuery1, Sql do
          begin
            Close;
            Clear;
            Add('select * from '+ p_table_name);
            Open;

            l_first_field_name:= FieldDefs[0].Name;
          end; // with ibQuery1, Sql
        end; // open_the_table_query

      procedure generate_dataset_class;
        begin
          with c_generate_dataset.create_generate_dataset(p_table_name,
              l_first_field_name, l_class_name, l_constructor_name, l_field_underscore,
              IbQuery1) do
          begin
            generate_dataset;

            save_to_file(f_exe_path+ '..\'+ k_raw_component_segment+ 'u_c_'+ p_table_name+ '.pas');
            dataset_memo_.Lines.Assign(m_c_result_list);

            Free;
          end; // with c_generate_dataset
        end; // generate_dataset_class

      procedure generate_module_class;
        begin
          with c_generate_module.create_generate_module(p_table_name,
              l_class_name, l_constructor_name, '_module') do
          begin
            generate_module;

            save_to_file(f_exe_path+ '..\'+ k_raw_component_segment+ 'u_c_'+ p_table_name+ m_module_suffix+ '.pas');
            module_memo_.Lines.Assign(m_c_result_list);
            Free;
          end; // with c_generate_module
        end; // generate_module_class

      procedure generate_edit_form;
          // -- a sample form with dbgrid, dbedit, dbnavigator
        begin
          with c_generate_form.create_generate_form(p_table_name, l_first_field_name) do
          begin
            generate_pas();
            save_to_file(f_exe_path+ '..\'+ k_raw_form_segment+ 'u_f_edit_'+ m_table_name+ '.pas');
            edit_form_pas_memo_.Lines.Assign(m_c_result_list);

            clear_generator;

            generate_dfm();
            save_to_file(f_exe_path+ '..\'+ k_raw_form_segment+ 'u_f_edit_'+ p_table_name+ '.dfm');
            edit_form_pas_memo_.Lines.Assign(m_c_result_list);

            Free;
          end; // c_generate_form.
        end; // generate_edit_form

      begin // generate_minimal_table_unit
        display('> '+ p_table_name);

        open_the_table_query;
        if l_first_field_name= ''
          then display_bug_stop('no_first_xxx');

        l_class_name:= 'c_'+ p_table_name;
        l_constructor_name:= 'create_'+ p_table_name;
        if field_underscore_.Checked
          then l_field_underscore:= '_'
          else l_field_underscore:= '';

        generate_dataset_class;
        generate_module_class;

        if form_.Checked
          then generate_edit_form;

        display('<');
      end; // generate_minimal_table_unit

    var g_table_name: String= '';

    procedure TForm1.ListBox1Click(Sender: TObject);
        // -- generate the unit for this table

      procedure display_fields(p_table_name: String);
        var l_field_def_index: Integer;
        begin
          with ibQuery1, Sql do
          begin
            Close;
            Clear;
            Add('select * from '+ p_table_name);
            Open;

            field_listbox_.Items.Clear;
            with FieldDefs do
              for l_field_def_index:= 0 to Count- 1 do
                with FieldDefs[l_field_def_index] do
                begin
                  field_listbox_.Items.Add(Name);
                end; // with FieldDefs, for l_field_def_index
          end; // with ibQuery1, Sql
        end; // display_fields

      begin // ListBox1Click
        with ListBox1 do
          g_table_name:= LowerCase(Items[ItemIndex]);

        // -- prepare the edit_form generation  
        with g_c_edit_form_list do
          if IndexOf(g_table_name)< 0
            then Add(g_table_name);

        if two_steps_.Checked
          then display_fields(g_table_name)
          else generate_minimal_table_unit(g_table_name);
      end; // ListBox1Click

    procedure TForm1.generate_Click(Sender: TObject);
      begin
        generate_minimal_table_unit(g_table_name)
      end; // generate_Click

    procedure TForm1.generate_project_Click(Sender: TObject);
      begin
        display_line;
        display('will generate test for ');
        display_strings(g_c_edit_form_list);

        with c_generate_dpr.create_generate_dpr('test_delphi_business_objects',
            k_raw_component_segment, k_raw_form_segment, k_result_segment) do
        begin
          generate_all(g_c_edit_form_list);

          Free;
        end; // c_generate_form.
      end; // generate_project_Click

end.


