// 002 u_c_generate_dpr
// 01 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_generate_dpr;
  interface
    uses Classes, u_c_basic_object
        , u_c_generator_2;

    type c_generate_dpr= class(c_generator)
                           m_raw_component_segment, m_raw_form_segment, m_result_dpr_segment: String;
                           _m_base_name: String;

                           Constructor create_generate_dpr(p_name,
                               p_raw_component_segment, p_raw_form_segment, p_result_dpr_segment: String);

                             procedure _generate_dpr(p_c_form_list: tStringList);
                             procedure _generate_dof;

                             procedure _generate_form(p_c_form_list: tStringList);

                           procedure generate_all(p_c_form_list: tStringList);
                         end; // c_generate_dpr

  implementation
    uses SysUtils
        , u_exe, u_c_display
        ;

    // -- c_generate_dpr

    Constructor c_generate_dpr.create_generate_dpr(p_name,
        p_raw_component_segment, p_raw_form_segment, p_result_dpr_segment: String);
      begin
        Inherited create_generator(p_name);

        _m_base_name:= p_name;

        m_raw_component_segment:= p_raw_component_segment;
        m_raw_form_segment:= p_raw_form_segment;
        m_result_dpr_segment:= p_result_dpr_segment;
      end; // create_generate_dpr

    procedure c_generate_dpr._generate_dpr(p_c_form_list: tStringList);
      var l_table_index: Integer;
          l_table_name: String;
      begin
        add_line('// 001 p_'+ _m_base_name);
        add_line('// 01 oct 2006');
        add_line('');
        add_line('(*$r+*)');
        add_line('');

        add_line_indent('program p_'+ _m_base_name+ ';');
        add_line_indent('uses');
        add_line('Forms,');
        add_line('u_'+ _m_base_name+ ' in ''u_'+ _m_base_name+ '.pas'' {test_form},');
        add_line('u_dm_database in ''u_dm_database.pas'' {dm_database: TDataModule}');
        add_line('');

        with p_c_form_list do
          for l_table_index:= 0 to Count- 1 do
          begin
            l_table_name:= Strings[l_table_index];
            add_line(', u_f_edit_'+ l_table_name+ ' in ''..\'+ m_raw_form_segment+ '\u_f_edit_'+ l_table_name+ '.pas'' {edit_'+ l_table_name+ '_form}');
          end;

        add_line(';');
        add_line_unindent('');
        add_line('{$R *.res}');
        add_line('');
        add_line_indent('begin');
        add_line('Application.Initialize;');
        add_line('Application.CreateForm(Ttest_form, test_form);');
        add_line('Application.CreateForm(Tdm_database, dm_database);');

        add_line('');
        with p_c_form_list do
          for l_table_index:= 0 to Count- 1 do
          begin
            l_table_name:= Strings[l_table_index];
            add_line('Application.CreateForm(Tedit_'+ l_table_name+ '_form, edit_'+ l_table_name+ '_form);');
          end;

        add_line('');

        add_line_unindent('Application.Run;');
        add_line('end.');

        save_to_file(f_exe_path+ '..\'+ m_result_dpr_segment+ 'p_'+ _m_base_name+ '.dpr');
        clear_generator;
      end; // _generate_dpr

    procedure c_generate_dpr._generate_dof;
      begin
        add_line('[FileVersion]');
        add_line('Version=6.0');
        add_line('[Compiler]');
        add_line('A=8');
        add_line('B=0');
        add_line('C=1');
        add_line('D=1');
        add_line('E=0');
        add_line('F=0');
        add_line('G=1');
        add_line('H=1');
        add_line('I=1');
        add_line('J=0');
        add_line('K=0');
        add_line('L=1');
        add_line('M=0');
        add_line('N=1');
        add_line('O=1');
        add_line('P=1');
        add_line('Q=0');
        add_line('R=0');
        add_line('S=0');
        add_line('T=0');
        add_line('U=0');
        add_line('V=1');
        add_line('W=0');
        add_line('X=1');
        add_line('Y=1');
        add_line('Z=1');
        add_line('ShowHints=1');
        add_line('ShowWarnings=1');
        add_line('UnitAliases=WinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE;');
        add_line('[Linker]');
        add_line('MapFile=0');
        add_line('OutputObjs=0');
        add_line('ConsoleApp=1');
        add_line('DebugInfo=0');
        add_line('RemoteSymbols=0');
        add_line('MinStackSize=16384');
        add_line('MaxStackSize=1048576');
        add_line('ImageBase=4194304');
        add_line('ExeDescription=');
        add_line('[Directories]');
        add_line('OutputDir=..\_exe');
        add_line('UnitOutputDir=..\_exe\dcu');
        add_line('PackageDLLOutputDir=');
        add_line('PackageDCPOutputDir=');
        add_line('SearchPath=..\'+ m_raw_form_segment+ ';..\'+ m_raw_component_segment);
        add_line('Packages=vcl;rtl;dbrtl;adortl;vcldb;vclx;bdertl;vcldbx;ibxpress;'
            + 'dsnap;cds;bdecds;qrpt;teeui;teedb;tee;dss;teeqr;visualclx;visualdbclx;'
            + 'dsnapcrba;dsnapcon;VclSmp;vclshlctrls;vclie;xmlrtl;inet;inetdbbde;inetdbxpress;'
            + 'inetdb;nmfast;webdsnap;websnap;dbexpress;dbxcds;indy;pk_connect_pannel;SnapDataset;DemoRules');
        add_line('Conditionals=');
        add_line('DebugSourceDirs=');
        add_line('UsePackages=0');
        add_line('[Parameters]');
        add_line('RunParams=');
        add_line('HostApplication=');
        add_line('Launcher=');
        add_line('UseLauncher=0');
        add_line('DebugCWD=');
        add_line('[Language]');
        add_line('ActiveLang=');
        add_line('ProjectLang=');
        add_line('RootDir=');
        add_line('[Version Info]');
        add_line('IncludeVerInfo=0');
        add_line('AutoIncBuild=0');
        add_line('MajorVer=1');
        add_line('MinorVer=0');
        add_line('Release=0');
        add_line('Build=0');
        add_line('Debug=0');
        add_line('PreRelease=0');
        add_line('Special=0');
        add_line('Private=0');
        add_line('DLL=0');
        add_line('Locale=1036');
        add_line('CodePage=1252');
        add_line('[Version Info Keys]');
        add_line('[HistoryLists\hlUnitAliases]');
        add_line('Count=1');
        add_line('Item0=WinTypes=Windows;WinProcs=Windows;DbiTypes=BDE;DbiProcs=BDE;DbiErrs=BDE;');

        save_to_file(f_exe_path+ '..\'+ m_result_dpr_segment+ 'p_'+ _m_base_name+ '.dof');
        clear_generator;
      end; // _generate_dof

    procedure c_generate_dpr._generate_form(p_c_form_list: tStringList);

      procedure _generate_main_pas;
        var l_table_index: Integer;
            l_table_name: String;
        begin
          add_line('// 001 u_'+ _m_base_name);
          add_line('// 01 oct 2006');
          add_line('');
          add_line('(*$r+*)');
          add_line('');

          add_line_indent('unit u_'+ _m_base_name+ ';');
          add_line_indent('interface');
          add_line_indent('uses');
          add_line('Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,');
          add_line('Dialogs, StdCtrls, Mask, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet,');
          add_line('IBDatabase;');
          add_line('');
          Inc(m_indentation, -4);
          add_line_indent('type');
          add_line('Ttest_form = class(TForm)');
          Inc(m_indentation, 4);

          with p_c_form_list do
          begin
            for l_table_index:= 0 to Count- 1 do
            begin
              l_table_name:= Strings[l_table_index];
              add_line(''+ l_table_name+ '_: TButton;');
            end;
            for l_table_index:= 0 to Count- 1 do
            begin
              l_table_name:= Strings[l_table_index];
              add_line('procedure '+ l_table_name+ '_Click(Sender: TObject);');
            end;
          end; // with p_c_form_list
          Dec(m_indentation, 2);

          add_line('private');
          add_line_unindent('public');
          add_line('end;');
          add_line('');
          add_line('var test_form: Ttest_form;');
          add_line_unindent('');
          add_line_indent('implementation');

          add_line_indent('uses');
          with p_c_form_list do
            for l_table_index:= 0 to Count- 1 do
            begin
              l_table_name:= Strings[l_table_index];

              if l_table_index> 0
                then add_line(', u_f_edit_'+ l_table_name)
                else add_line('u_f_edit_'+ l_table_name);
            end;
          add_line_unindent(';');

          add_line('');
          add_line('{$R *.dfm}');

          with p_c_form_list do
            for l_table_index:= 0 to Count- 1 do
            begin
              l_table_name:= Strings[l_table_index];

              add_line('');
              add_line_indent('procedure Ttest_form.'+ l_table_name+ '_Click(Sender: TObject);');
              add_line_indent('begin');
              add_line('with edit_'+ l_table_name+ '_form do');
              add_line_indent('begin');
              add_line('open_dataset();');
              add_line('ShowModal;');
              add_line_unindent('edit_'+ l_table_name+ '_form.close_dataset();');
              add_line_unindent('end; // with edit_'+ l_table_name+ '_form');
              add_line('end; // '+ l_table_name+ '_Click');
            end;

          add_line('');
          Inc(m_indentation, -6);
          add_line('end.');

          save_to_file(f_exe_path+ '..\'+ m_result_dpr_segment+ 'u_'+ _m_base_name+ '.pas');
          clear_generator;
        end; // _generate_main_pas

      procedure _generate_main_dfm;
        var l_table_index: Integer;
            l_table_name: String;
        begin
          add_line_indent('object test_form: Ttest_form');
          add_line('Left = 200');
          add_line('Top = 130');
          add_line('Width = 120');
          add_line('Height = 245');
          add_line('Caption = ''test_form''');
          add_line('Color = clBtnFace');
          add_line('Font.Charset = DEFAULT_CHARSET');
          add_line('Font.Color = clWindowText');
          add_line('Font.Height = -11');
          add_line('Font.Name = ''MS Sans Serif''');
          add_line('Font.Style = []');
          add_line('OldCreateOrder = False');
          add_line('PixelsPerInch = 96');
          add_line('TextHeight = 13');

          with p_c_form_list do
            for l_table_index:= 0 to Count- 1 do
            begin
              l_table_name:= Strings[l_table_index];

              add_line_indent('object '+ l_table_name+ '_: TButton');
              add_line('Left = 16');
              add_line('Top = '+ IntToStr(5+ l_table_index* 30));
              add_line('Width = 75');
              add_line('Height = 25');
              add_line('Caption = '''+ l_table_name+ '_''');
              add_line('TabOrder = 0');
              add_line_unindent('OnClick = '+ l_table_name+ '_Click');
              add_line('end');
            end;

          Dec(m_indentation, 2);
          add_line('end');

          save_to_file(f_exe_path+ '..\'+ m_result_dpr_segment+ 'u_'+ _m_base_name+ '.dfm');
          clear_generator;
        end; // _generate_main_dfm

      begin // _generate_form
        _generate_main_pas;
        _generate_main_dfm;
      end; // _generate_form

    procedure c_generate_dpr.generate_all(p_c_form_list: tStringList);
      begin
        _generate_dpr(p_c_form_list);
        _generate_dof;
        _generate_form(p_c_form_list);
      end; // generate_all

    begin // u_c_generate_dpr
    end. // u_c_generate_dpr


