// 002 u_c_generate_form
// 30 sep 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_generate_form;
  interface
    uses u_c_basic_object
        , u_c_generator_2;

    type c_generate_form= class(c_generator)
                            m_table_name, m_first_field_name: String;

                            Constructor create_generate_form(p_table_name, p_first_field_name: String);

                            procedure generate_pas;
                            procedure generate_dfm;
                          end; // c_generate_form

  implementation
    uses SysUtils, u_c_display;

    // -- c_generate_form

    Constructor c_generate_form.create_generate_form(p_table_name, p_first_field_name: String);
      begin
        Inherited create_generator(p_table_name);
        m_table_name:= p_table_name;
        m_first_field_name:= p_first_field_name;
      end; // create_generate_form

    procedure c_generate_form.generate_pas;
      begin
        add_line('// 001 u_'+ m_table_name);
        add_line('// 01 oct 2006');
        add_line('');
        add_line('(*$r+*)');
        add_line('');

        add_line_indent('unit u_f_edit_'+ m_table_name+ ';');
        add_line_indent('interface');
        add_line('uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms');
        Inc(m_indentation, 4);
        add_line(', Dialogs, StdCtrls, Mask, ExtCtrls, DBCtrls, Grids, DBGrids, DB, IBCustomDataSet');
        add_line(', u_c_'+ m_table_name+ ', u_c_'+ m_table_name+ '_module');
        add_line(';');
        add_line('');
        Inc(m_indentation, -4);

        add_line_indent('type');
        add_line('Tedit_'+ m_table_name+ '_form= class(TForm)');
        Inc(m_indentation, 4);
        add_line('DBGrid1: TDBGrid;');
        add_line('DBNavigator1: TDBNavigator;');
        add_line('db_'+ m_first_field_name+ '_edit: TDBEdit;');
        add_line_unindent('procedure FormCreate(Sender: TObject);');
        add_line('private');
        add_line_indent('public');
        add_line('m_c_'+ m_table_name+ '_module: c_'+ m_table_name+ '_module;');
        add_line('');
        add_line('// -- references');
        add_line(''+ m_table_name+ '_e: c_'+ m_table_name+ ';');
        add_line('');
        add_line('procedure initialize_local_references;');
        add_line('procedure link_controls;');
        add_line('procedure open_dataset;');
        add_line('procedure close_dataset;');
        add_line('procedure open_at(p_'+ m_first_field_name+ ': String);');
        Inc(m_indentation, -4);
        add_line('end; // Tedit_'+ m_table_name+ '_form');

        add_line_unindent('');
        add_line('var edit_'+ m_table_name+ '_form: Tedit_'+ m_table_name+ '_form;');
        add_line_unindent('');
        add_line_indent('implementation');
        add_line('uses // u_display');
        Inc(m_indentation, 4);
        add_line('//,');
        add_line('u_dm_database');
        add_line(';');
        add_line('');
        Inc(m_indentation, -4);
        add_line('{$R *.dfm}');
        add_line('');

        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.FormCreate(Sender: TObject);');
        add_line_indent('begin');
        add_line_unindent('m_c_'+ m_table_name+ '_module:= c_'+ m_table_name+ '_module.create_'+ m_table_name+ '_module(Self, ''SELECT * FROM '+ m_table_name+ ''');');
        add_line('end; // FormCreate');
        add_line_unindent('');
        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.initialize_local_references;');
        add_line_indent('begin');
        add_line('with m_c_'+ m_table_name+ '_module do');
        add_line_indent('begin');
        add_line_unindent(''+ m_table_name+ '_e:= _'+ m_table_name+ ';');
        add_line_unindent('end; // with m_c_'+ m_table_name+ '_module');
        add_line('end; // initialize_local_references');
        add_line_unindent('');
        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.link_controls;');
        add_line_indent('begin');
        add_line('with m_c_'+ m_table_name+ '_module do');
        add_line_indent('begin');
        add_line('// -- link all the db_xxx datasources');
        add_line('db_'+ m_first_field_name+ '_edit.DataSource:= _'+ m_table_name+ '_datasource;');
        add_line('');
        add_line('dbGrid1.DataSource:= _'+ m_table_name+ '_datasource;');
        add_line_unindent('dbNavigator1.DataSource:= _'+ m_table_name+ '_datasource;');
        add_line('end; // with m_c_'+ m_table_name+ '_module do');
        Inc(m_indentation, -2);
        add_line('end; // link_controls');
        add_line_unindent('');
        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.open_dataset;');
        add_line_indent('begin');
        add_line('m_c_'+ m_table_name+ '_module._open_dataset();');
        add_line('initialize_local_references;');
        add_line_unindent('link_controls;');
        add_line('end; // open_dataset');
        add_line_unindent('');
        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.close_dataset;');
        add_line_indent('begin');
        add_line_unindent(''+ m_table_name+ '_e.Close();');
        add_line('end; // close_dataset');
        add_line_unindent('');
        add_line_indent('procedure Tedit_'+ m_table_name+ '_form.open_at(p_'+ m_first_field_name+ ': String);');
        add_line_indent('begin');
        add_line('open_dataset();');
        add_line(''+ m_table_name+ '_e.Locate('''+ m_first_field_name+ ''', p_'+ m_first_field_name+ ', []);');
        add_line('ShowModal;');
        add_line_unindent('close_dataset();');
        add_line('end; // open_at');
        add_line('');
        add_line('');
        Inc(m_indentation, -4);
        add_line('end.');
      end; // generate_unit

    procedure c_generate_form.generate_dfm;
      begin
        add_line_indent('object edit_'+ m_table_name+ '_form: Tedit_'+ m_table_name+ '_form');
        add_line('Left = 330');
        add_line('Top = 130');
        add_line('Width = 500');
        add_line('Height = 259');
        add_line('Caption = ''edit_'+ m_table_name+ '_form''');
        add_line('Color = clBtnFace');
        add_line('Font.Charset = DEFAULT_CHARSET');
        add_line('Font.Color = clWindowText');
        add_line('Font.Height = -11');
        add_line('Font.Name = ''MS Sans Serif''');
        add_line('Font.Style = []');
        add_line('OldCreateOrder = False');
        add_line('OnCreate = FormCreate');
        add_line('PixelsPerInch = 96');
        add_line('TextHeight = 13');

        add_line_indent('object DBGrid1: TDBGrid');
        add_line('Left = 16');
        add_line('Top = 16');
        add_line('Width = 449');
        add_line('Height = 129');
        add_line('TabOrder = 0');
        add_line('TitleFont.Charset = DEFAULT_CHARSET');
        add_line('TitleFont.Color = clWindowText');
        add_line('TitleFont.Height = -11');
        add_line('TitleFont.Name = ''MS Sans Serif''');
        add_line_unindent('TitleFont.Style = []');
        add_line('end');
        add_line_indent('object DBNavigator1: TDBNavigator');
        add_line('Left = 16');
        add_line('Top = 152');
        add_line('Width = 240');
        add_line('Height = 25');
        add_line_unindent('TabOrder = 2');
        add_line('end');

        add_line_indent('object db_'+ m_first_field_name+ '_edit: TDBEdit');
        add_line('Left = 16');
        add_line('Top = 184');
        add_line('Width = 121');
        add_line('Height = 21');
        add_line('DataField = '''+ m_first_field_name+ '''');
        add_line_unindent('TabOrder = 1');
        add_line_unindent('end');

        add_line('end');
      end; // generate_dfm

    begin // u_c_generate_form
    end. // u_c_generate_form


