// 002 u_c_generate_sql_queries
// 30 sep 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_generate_sql_queries;
  interface
    uses Classes, IbQuery, u_c_basic_object
        , u_c_generator_2;

    type c_generate_sql_queries= class(c_generator)
                                   m_table_name, m_first_field_name: String;
                                   m_c_update_sql, m_c_insert_sql, m_c_delete_sql, m_c_refresh_sql: tStringList;

                                   Constructor create_generate_sql_queries(p_table_name, p_first_field_name: String);

                                   procedure generate_sql_queries(p_c_ib_query: tIbQuery);
                                 end; // c_generate_sql_queries

  implementation
    uses SysUtils, u_c_display;

    // -- c_generate_sql_queries

    Constructor c_generate_sql_queries.create_generate_sql_queries(p_table_name, p_first_field_name: String);
      begin
        Inherited create_generator(p_table_name);
        m_table_name:= p_table_name;
        m_first_field_name:= p_first_field_name;
      end; // create_generate_sql_queries

    procedure c_generate_sql_queries.generate_sql_queries(p_c_ib_query: tIbQuery);

      procedure generate_update;
          // -- update FACTURE
          // -- set
          // --   F_NUMERO= :F_NUMERO,
          // --   F_CLIENT= :F_CLIENT,
          // --   F_DATE= :F_DATE,
          // --   F_MONTANT = :F_MONTANT
          // -- where
          // --   F_ID = :OLD_F_ID
        var l_field_def_index: Integer;
            l_field_name: String;
            l_field_line: String;
        begin
          add_line_indent('UPDATE '+ m_table_name+ '');
          add_line_indent('SET');
          with p_c_ib_query do
            for l_field_def_index:= 0 to FieldCount- 1 do
              with FieldDefs[l_field_def_index] do
              begin
                l_field_name:= UpperCase(Name);
                if l_field_name<> UpperCase(m_first_field_name)
                  then begin
                      l_field_line:= l_field_name+ '= :'+ l_field_name;
                      if l_field_def_index< FieldCount- 1
                        then l_field_line:= l_field_line+ ',';
                      add_line(l_field_line);
                    end;
              end;
          add_line_indent('WHERE');
          add_line(''+ m_first_field_name+ ' = :OLD_'+ m_first_field_name+ '');

          m_c_update_sql:= tStringList.Create;
          m_c_update_sql.Text:= m_c_result_list.Text;
          clear_generator;
        end; // generate_update

      procedure generate_insert;
          // -- insert into '+ m_table_name+ '
          // --   (F_MONTANT)
          // -- values
          // --   (:F_MONTANT)
        var l_field_def_index: Integer;
            // l_field_name: String;
            l_field_line: String;
        begin
          add_line('INSERT INTO '+ m_table_name+ '');
          Inc(m_indentation, 4);

          l_field_line:= '(';
          with p_c_ib_query do
            for l_field_def_index:= 0 to FieldCount- 1 do
              with FieldDefs[l_field_def_index] do
              begin
                l_field_line:= l_field_line+ UpperCase(Name);
                if l_field_def_index< FieldCount- 1
                  then l_field_line:= l_field_line+ ',';
              end;
          add_line(l_field_line+ ')');

          Dec(m_indentation, 2);
          add_line_indent('VALUES');

          l_field_line:= '(';
          with p_c_ib_query do
            for l_field_def_index:= 0 to FieldCount- 1 do
              with FieldDefs[l_field_def_index] do
              begin
                l_field_line:= l_field_line+ ':'+ UpperCase(Name);
                if l_field_def_index< FieldCount- 1
                  then l_field_line:= l_field_line+ ',';
              end;
          add_line(l_field_line+ ')');

          m_c_insert_sql:= tStringList.Create;
          m_c_insert_sql.Text:= m_c_result_list.Text;
          clear_generator;
        end; // generate_insert

      procedure generate_delete;
          // -- delete from '+ m_table_name+ '
          // -- where
          // --   '+ m_first_field_name+ ' = :OLD_F_ID
        begin
          add_line_indent('DELETE FROM '+ m_table_name+ '');
          add_line_indent('WHERE');
          add_line(''+ m_first_field_name+ ' = :OLD_'+ m_first_field_name+ '');

          m_c_delete_sql:= tStringList.Create;
          m_c_delete_sql.Text:= m_c_result_list.Text;
          clear_generator;
        end; // generate_delete

      procedure generate_select;
          // -- Select
          // --   '+ m_first_field_name+ ',
          // --   F_NUMERO,
          // --   F_CLIENT,
          // --   F_DATE,
          // --   F_MONTANT
          // -- from '+ m_table_name+ '
          // -- where
          // --   '+ m_first_field_name+ ' = :'+ m_first_field_name+ '
        begin
          // -- todo
          add_line('SELECT');
          Inc(m_indentation, 4);
          add_line(''+ m_first_field_name+ ',');
          add_line('F_NUMERO,');
          add_line('F_CLIENT,');
          add_line('F_DATE,');
          add_line_unindent('F_MONTANT');
          add_line('FROM '+ m_table_name+ '');
          add_line_indent('WHERE');
          add_line(''+ m_first_field_name+ ' = :'+ m_first_field_name+ '');

          m_c_refresh_sql:= tStringList.Create;
          m_c_refresh_sql.Text:= m_c_result_list.Text;
          clear_generator;
        end; // generate_select

      begin // generate_sql_queries
        generate_update;
        generate_insert;
        generate_delete;
        generate_select;
      end; // generate_sql_queries

    begin // u_c_generate_sql_queries
    end. // u_c_generate_sql_queries

items has 2 NOT NULL fields

update ITEMS
set
  PARTNO = :PARTNO,
  QTY = :QTY,
  DISCOUNT = :DISCOUNT
where
  ITEMNO = :OLD_ITEMNO and
  ORDERNO = :OLD_ORDERNO

